﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;
using System.IO;
using ccc;
using OpenCL;

namespace OpenCL
{
    class Alignment
    {
        public static void Main(String[] args)
        {
            BilingualAlignment1();
        }

        static void BilingualAlignment1()
        {
            CEDict dict = new CEDict("dictionary/cedict_ts.u8");

            Debug.open("corpus/BabelTestDebug.txt");
            TextFile textFile = new TextFile("corpus/BabelTest.txt");
            foreach (String line in textFile.lines())
            {
                if (line.Trim().Length == 0) continue;
                //                Debug.println(line);
                String[] fields = line.Split('\t');
                String id = fields[0];
                String english = fields[1].ToLower();
                String chinese = fields[2];
                Debug.println("=================================================================");
                Debug.println(english);
                Debug.println(chinese);
                foreach (String cword in Regexp.matches(@"[^\s]+", chinese, 0))
                {
                    Debug.print("  " + cword);
                    CEWord cwordObj = dict.get(cword);
                    String wordText = "";
                    if (cwordObj != null)
                    {
                        wordText = cwordObj.ToString().ToLower();
                        Debug.print("\t(" + wordText.ToString() + ")");
                    }
                    else
                        Debug.print("\t?");
                    Debug.println("");
                    bool isMatch = false;
                    foreach (String eword in Regexp.matches(@"[\w]+", english, 0))
                    {
                        if (wordText.IndexOf("/" + eword + "/") >= 0)
                        {
                            isMatch = true;
                            Debug.println("\t=> (" + eword + ") ");
                        }
                    }
                    if (!isMatch)
                        Debug.println("\t=> ?");
                }
                Debug.println("");
            }

            Debug.close();
        }
    }
}
