﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;

namespace OpenCL
{
    class DictionaryProcess
    {
        static void Main(string[] args)
        {
            buildTraditionalSimplifiedOnly();
            buildTaiwanToChinaPhrase();
        }

        static void buildTraditionalSimplifiedOnly()
        {
            TextFile file = new TextFile("dictionary/chinese/TraditionalToSimplified.txt");
            Debug.open("dictionary/chinese/TraditionalToSimplifiedOnly.txt");
            foreach (String line in file.lines())
            {
                if (line.StartsWith("#")) continue;
                String traditional = STR.head(line, "\t");
                String simplified = STR.tail(line, "\t");
                if (!traditional.Equals(simplified))
                    Debug.println(STR.replace(line, "\t", "="));
            }
            Debug.close();
        }

        static void buildTaiwanToChinaPhrase()
        {
            String text = TextFile.fileToText("dictionary/chinese/PhraseTaiwanToChinaComma.txt");
            String toText = STR.expand(text, ";=\r\n|→=\t| =");
            TextFile.textToFile(toText, "dictionary/chinese/PhraseTaiwanToChina.txt");
        }
    }
}
