using System;
using System.Collections.Generic;
using System.Text;

namespace OpenCL
{
    class ChineseConverter
    {
        Dict s2t, t2s;

        public static void Main(String[] args) {
            ChineseConverter converter = new ChineseConverter();
            String corpus = TextFile.fileToText(@"corpus/1500.txt");
            corpus = STR.expand(corpus, "\r=|\n=|\b=");
            String[] lines = corpus.Split('C');
            int i = 0;
            foreach (String line in lines)
            {
                String tline = converter.simplifiedToTraditional(line);
                Console.WriteLine(i + ":" + tline);
                i++;
            }
        }

        public ChineseConverter() {
            t2s = new Dict("dictionary/c²rӪ.txt");
            s2t = new Dict();
            foreach (KeyValuePair<String, String> pair in t2s)
            {
                if (!s2t.ContainsKey(pair.Value))
                    s2t.Add(pair.Value, pair.Key);
            }
        }

        public String simplifiedToTraditional(String simplifiedText)
        {
            StringBuilder traditionalText = new StringBuilder();
            for (int i=0; i<simplifiedText.Length; i++) 
            {
                String ch = simplifiedText[i]+"";
                if (s2t.ContainsKey(ch))
                    traditionalText.Append(s2t[ch]);
                else
                    traditionalText.Append(ch);
            }
            return traditionalText.ToString();
        }

        public String traditionalToSimplified(String traditionalText)
        {
            StringBuilder simplifiedText = new StringBuilder();
            for (int i = 0; i < traditionalText.Length; i++)
            {
                String ch = simplifiedText[i] + "";
                if (t2s.ContainsKey(ch))
                    simplifiedText.Append(t2s[ch]);
                else
                    simplifiedText.Append(ch);
            }
            return simplifiedText.ToString();
        }
    }
}
