﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace OpenDLMClient
{
    public partial class FormFileBrowser : Form
    {
        FormMetadata formMetadata = new FormMetadata();

        public FormFileBrowser()
        {
            InitializeComponent();

            formMetadata.Visible = false;
//            showDir();
        }

        // author, license, update time, comments

        private void listViewFileBrowser_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
                e.Effect = DragDropEffects.All;
            else
                e.Effect = DragDropEffects.None;
        }

        public void addFile(String filePath)
        {
            FileInfo file = new FileInfo(filePath);
            ListViewItem item = new ListViewItem();
            String filename = file.Name;
            long length = file.Length;
            DateTime createTime = file.CreationTime;
            DateTime lastWriteTime = file.LastWriteTime;
            String attributes = file.Attributes.ToString();
            String author = "";
            item.Text = filePath;
            item.SubItems.Add(length.ToString());
            item.SubItems.Add(createTime.ToString());
            item.SubItems.Add(author);
            item.SubItems.Add(attributes);
            listViewFileBrowser.Items.Add(item);
        }

        private void listViewFileBrowser_DragDrop(object sender, DragEventArgs e)
        {
            string[] s = (string[]) e.Data.GetData(DataFormats.FileDrop, false);
            int i;
            for (i = 0; i < s.Length; i++)
            {
                addFile(s[i]);
            }
        }

        private void contextMenuStripFilePopup_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            String op = e.ClickedItem.Text;
            if (op.Equals("Edit"))
            {
            }
            else if (op.Equals("Metadata"))
            {
                formMetadata.Visible = true;
            }
            else if (op.Equals("Publish"))
            {
            }

            // MessageBox.Show(e.ClickedItem.Text);
        }
    }
}