﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using ccc;

namespace MetaWebEditor
{
    public partial class FormMetaWebEditor:Form
    {
        TextFile mMetaLog = new TextFile("MetaLog.txt", FileMode.Append);
        TextFile mHistoryLog = new TextFile("History.txt", FileMode.Append);

        String mUrl
        {
            get { return toolStripComboBoxUrl.Text; }
            set { toolStripComboBoxUrl.Text = value; }
        }
        String mMetadata
        {
            get { return richTextBoxMetadata.Text; }
            set { richTextBoxMetadata.Text = value; }
        }
        String mTitle {
            get { return toolStripComboBoxTitle.Text; }
            set { toolStripComboBoxTitle.Text = value; }
        }
        String mLicense {
            get { return toolStripComboBoxLicense.Text; }
            set { toolStripComboBoxLicense.Text = value; }
        }
        String mType {
            get { return toolStripComboBoxType.Text; }
            set { toolStripComboBoxType.Text = value; }
        }

        ToolStripItemCollection mPaste
        {
            get { return contextMenuStripPaste.Items; }
        }

        public FormMetaWebEditor()
        {
            InitializeComponent();
            goUrl("www.google.com");
//            splitContainerMain.Panel1Collapsed = true;
        }

        private void FormMetaWebEditor_Load(object sender, EventArgs e)
        {

        }

        private void panelTop_Paint(object sender, PaintEventArgs e)
        {

        }

        private void dateTimePicker1_ValueChanged(object sender, EventArgs e)
        {

        }

        private void toolStripComboBoxUrl_Click(object sender, EventArgs e)
        {
        }

        private void toolStripButtonBack_Click(object sender, EventArgs e)
        {
            webBrowser.GoBack();
        }

        private void toolStripButtonNext_Click(object sender, EventArgs e)
        {
            webBrowser.GoForward();
        }

        private void toolStripButtonReload_Click(object sender, EventArgs e)
        {
            webBrowser.Refresh();
        }

        private void toolStripButtonCancel_Click(object sender, EventArgs e)
        {
            webBrowser.Stop();
        }

        private void toolStripComboBoxUrl_KeyPress(object sender, KeyPressEventArgs e)
        {
        }

        private void toolStripComboBoxUrl_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                goUrl(toolStripComboBoxUrl.Text);
            }
        }

        public void goUrl(String url)
        {
            if (url.IndexOf("://") < 0)
                url = "http://" + url;
            webBrowser.Navigate(url);
        }

        private void webBrowser_Navigating(object sender, WebBrowserNavigatingEventArgs e)
        {
        }

        private void webBrowser_Navigated(object sender, WebBrowserNavigatedEventArgs e)
        {
            mUrl = webBrowser.Url.ToString();
            mHistoryLog.writeln(mUrl);
        }

        private void toolStripButtonMore_Click(object sender, EventArgs e)
        {
            if (toolStripButtonMore.Text.Equals("More"))
            {
                toolStripButtonMore.Text = "Less";
                splitContainerMain.Panel1Collapsed = false;
            }
            else
            {
                toolStripButtonMore.Text = "More";
                splitContainerMain.Panel1Collapsed = true;
            }
        }

        private void webBrowser_FileDownload(object sender, EventArgs e)
        {
        }

        /* Metadata
        
        Title:
        Creator:
        Type:
        License:
        Encoding:
        Links:
        Subject:
        Publisher:
        Contributor:
        Format:
        Identifier:
        Source:
        Language:
        Relation:
        Coverage:

         */
        public void initMetadata()
        {
            mMetadata = "";
            richTextBoxEditMetadata.Text = "Title:\n Type:\n License:\n Encoding:\n Links:\n Subject:\n Publisher:\n Contributor:\n  Format:\n Identifier:\n Source:\n Language:\n Relation:\n Coverage:\n";
        }

        public void extractMetadata()
        {
            String title = webBrowser.DocumentTitle;
            String html = webBrowser.DocumentText;

            mMetadata += "Encoding:"+webBrowser.Document.Encoding.ToString() + "\n";
            mMetadata += "Links:" + webBrowser.Document.Links.Count.ToString() + "\n";

            if (title == null || title.Trim().Length == 0)
            {
                title = STR.innerText(html, "<title>", "</title>");
            }
            mTitle = title;
            String license = extractLicense();
            if (license.Length > 0)
                mMetadata += "License:" + license;
            mMetadata += "\n";
        }

        public String extractLicense()
        {
            String license = "";
            String url = webBrowser.Url.ToString();
            String host = webBrowser.Url.Host.ToString();
            String html = webBrowser.DocumentText.ToLower();
            if (host.EndsWith(".wikipedia.org") || host.EndsWith(".wiktionary.org") || 
                host.EndsWith(".wikiquote.org") || host.EndsWith(".wikibooks.org") ||
                host.EndsWith(".wikisource.org") || host.EndsWith(".wikinews.org") || 
                host.EndsWith(".wikimedia.org") || host.EndsWith(".wikiversity.org") ||
                host.EndsWith(".mediawiki.org"))
                license = "GFDL";
            // if (host.EndsWith(".archive.org") ....
/*            else if (host.EndsWith(".youtube.com"))
            {
                if (html.IndexOf("http://tw.youtube.com/results?search_query=creativecommons&search=tag")>=0 || html.IndexOf("http://tw.youtube.com/results?search_query=cc&search=tag"))
                    license = "
            }
 */
            else if (url.StartsWith("http://www.guttenberg.org/files/"))
                license = "Public Domain";
            else // if (url.StartsWith("http://www.flickr.com/photos/"))
            {
                if (html.IndexOf("http://www.loc.gov/rr/print/195_copr.html#noknown") >= 0)
                    license = "No known restrictions on publication";
                else if (html.IndexOf("http://creativecommons.org/licenses/publicdomain/") >= 0)
                    license = "Public Domain";
                else if (html.IndexOf("http://creativecommons.org/licenses/by/") >= 0)
                    license = "cc:by";
                else if (html.IndexOf("http://creativecommons.org/licenses/by-nd/") >= 0)
                    license = "cc:by-nd";
                else if (html.IndexOf("http://creativecommons.org/licenses/by-nc-nd/") >= 0)
                    license = "cc:by-nc-nd";
                else if (html.IndexOf("http://creativecommons.org/licenses/by-nc/") >= 0)
                    license = "cc:by-nc";
                else if (html.IndexOf("http://creativecommons.org/licenses/by-nc-sa/") >= 0)
                    license = "cc:by-nc-sa";
                else if (html.IndexOf("http://creativecommons.org/licenses/by-sa/") >= 0)
                    license = "cc:by-sa";
            }
            
/*            else
            {
                foreach (String line in Regexp.matches("<a\\s[^>]*rel=['\\\"]license['\\\"][^<>]*>", html, 0))
                {
                    license += line + "\n";
                }
            }*/
            return license;
        }

        private void webBrowser_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {
            initMetadata();
            extractMetadata();
            mPaste.Clear();
            String[] pasteItems = { mUrl, mTitle, DateTime.Now.ToString() };
            foreach (String item in pasteItems)
                mPaste.Add(item);
        }

        public void addTag()
        {
            mMetadata += "Tag:" + comboBoxTag.Text + "\n";
        }

        private void comboBoxTag_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                addTag();
            }
        }

        private void buttonSave_Click(object sender, EventArgs e)
        {
            String saveText = STR.replace("<page url=\"" + mUrl + "\">\n" + mMetadata + "</page>\n", "\n", "\r\n");
            mMetaLog.write(saveText);
            richTextBoxMsg.Text += saveText;
        }

        private void FormMetaWebEditor_FormClosing(object sender, FormClosingEventArgs e)
        {
            mMetaLog.close();
            mHistoryLog.close();
        }

        private void buttonTagAdd_Click(object sender, EventArgs e)
        {
            addTag();
        }

        private void contextMenuStripPaste_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            Clipboard.Clear();
            Clipboard.SetText(e.ClickedItem.Text);
            richTextBoxMetadata.Paste();
        }
    }
}

/*
            if (toolStripLabelMore.Text.ToLower().Equals("more"))
            {
                toolStripLabelMore.Text = "less";
                splitContainerMain.Panel1Collapsed = false;
            }
            else
            {
                toolStripLabelMore.Text = "more";
                splitContainerMain.Panel1Collapsed = true;
            }
*/